=== debian/changelog ===
soplex (7.1.6+dfsg-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 7.1.6+dfsg

 -- Timo Röhling <roehling@debian.org>  Mon, 27 Oct 2025 22:22:09 +0100
