=== debian/watch ===
Version: 5

Template: Github
Owner: scipopt
Project: soplex
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/release-@ANY_VERSION@
Uversion-Mangle: s%(\d)(\d)(\d)%$1.$2.$3%
Dversion-Mangle: auto
Repack-Suffix: +dfsg
Repack: yes
